autoweka

## Class ExperimentBatch.ExperimentComponent

- java.lang.Object
- - autoweka.ExperimentBatch.ExperimentComponent

- Enclosing class:
    ExperimentBatch

      public static class ExperimentBatch.ExperimentComponent
      extends java.lang.Object

  Captures all the settings of an experiment that are not related to a dataset

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `java.util.List<java.lang.String>` | `allowedClassifiers` Forces Auto-WEKA to only use the list of classifiers here - if it is empty, then Auto-WEKA will try to use everything that it can
    `boolean` | `attributeSelection` Boolean indicating if Attribute/Feature selection should happen
    `float` | `attributeSelectionTimeout` How many seconds should be spent performing attribute selection?
    `java.lang.String` | `constructor` The class name of the ExperimentConstructor to use
    `java.util.List<java.lang.String>` | `constructorArgs` Any additional arguments that the ExperimentConstructor may want
    `java.lang.String` | `extraProps` The property string with any extra properties that the experiment might need
    `java.lang.String` | `instanceGenerator` The class name of the instance generator
    `java.lang.String` | `instanceGeneratorArgs` The property string that the instance generator will use to make instances
    `java.lang.String` | `memory` The string passed to the Xmx argument of a sub process limiting the RAM that WEKA will have
    `java.lang.String` | `name` The experiment name's prefix
    `java.lang.String` | `resultMetric` The name of the result metric to use - see ClassiferResult.Metric
    `float` | `trainTimeout` How many seconds should be spent training a set of hyperparameters on a specific partition of the training and test data?.
    `java.util.List<Experiment.TrajectoryPointExtra>` | `trajectoryPointExtras` For analysis experiements, these extra classifier evaluations will be done for every point along the trajectory.
    `float` | `tunerTimeout` How many seconds should be spent for this experiment overall? (IE the SMBO method's budget)

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ExperimentComponent()`

  - ### Method Summary

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### name

          public java.lang.String name

      The experiment name's prefix

    - #### resultMetric

          public java.lang.String resultMetric

      The name of the result metric to use - see ClassiferResult.Metric

    - #### constructor

          public java.lang.String constructor

      The class name of the ExperimentConstructor to use

    - #### constructorArgs

          public java.util.List<java.lang.String> constructorArgs

      Any additional arguments that the ExperimentConstructor may want

    - #### instanceGenerator

          public java.lang.String instanceGenerator

      The class name of the instance generator

    - #### instanceGeneratorArgs

          public java.lang.String instanceGeneratorArgs

      The property string that the instance generator will use to make instances

    - #### tunerTimeout

          public float tunerTimeout

      How many seconds should be spent for this experiment overall? (IE the SMBO method's budget)

    - #### trainTimeout

          public float trainTimeout

      How many seconds should be spent training a set of hyperparameters on a specific partition of the training and test data?. Note that this is more of a guideline, Auto-WEKA has quite a bit of slack built into to accomodate classifiers that can return partial results, or ones that decide to offload training onto their evaluation phase.

    - #### attributeSelection

          public boolean attributeSelection

      Boolean indicating if Attribute/Feature selection should happen

    - #### attributeSelectionTimeout

          public float attributeSelectionTimeout

      How many seconds should be spent performing attribute selection?

    - #### memory

          public java.lang.String memory

      The string passed to the Xmx argument of a sub process limiting the RAM that WEKA will have

    - #### extraProps

          public java.lang.String extraProps

      The property string with any extra properties that the experiment might need

    - #### trajectoryPointExtras

          public java.util.List<Experiment.TrajectoryPointExtra> trajectoryPointExtras

      For analysis experiements, these extra classifier evaluations will be done for every point along the trajectory. For example, if we want to look at the Testing performance all the way along, we would add a new TrajectoryPointExtra that contains an instance string of 'default', since that causes Auto-WEKA to preserve the provided training/test split

    - #### allowedClassifiers

          public java.util.List<java.lang.String> allowedClassifiers

      Forces Auto-WEKA to only use the list of classifiers here - if it is empty, then Auto-WEKA will try to use everything that it can

  - ### Constructor Detail

    - #### ExperimentComponent

          public ExperimentComponent()